# amdserialize
amdserialize is the task used to output the results of a construction task.
This output will be combine into a layer by a minifier (like UglifyJS) or a concatenation task (like grunt-contrib-concat).

### amdserialize (layerName, buildConfig, loaderConfig, outputProp)
Write all the files generated by a construction task to the `buildConfig.dir` directory.
This task will also find the images that may have been included in the css files required with a plugin.
Set the `outputProp` with the list of written files.

#### Arguments
1. layerName _(String)_: The layer name.
1. buildConfig _(String)_: Name of the property where the build configuration is stored. 
1. loaderConfig _(String)_: Name of the property where the amd loader configuration is stored. 
1. outputProp _(String)_: Name of the property where the list of generated files will be stored. 

#### Task configuration
This task does not use grunt configuration.

#### Results
The `outputProp` will contain the following object : 
```js
{
    header: String, // The text that should be written at the beginning of the layer
    layer: String, // The layer name
    modules: {
        abs: [], // list of module files paths (e.g., ./tmp/myapp/src.js)
        rel: []  // list of module files paths relative to the `buildConfig.dir` directory (e.g., ./myapp/src.js)
    },
    plugins: {
        abs: [], // list of plugin files paths (e.g., ./tmp/myapp/nls/src_fr.js)
        rel: []  // list of plugin files paths relative to the `buildConfig.dir` directory (e.g., ./myapp/nls/src_fr.js)
    }
}
```
